package com.dafreitag.app.machine;

import com.dafreitag.app.states.AppInformationState;
import com.dafreitag.app.states.AppGameState;
import com.dafreitag.app.states.AppTitleScreenState;
import javafx.stage.Stage;

public class AppMachine {
    AppState appSplashState;
    AppState appCopyrightState;
    AppState appGameState; 

    AppState appState;

    public AppMachine () {
        appSplashState    = new AppTitleScreenState(this);
        appCopyrightState = new AppInformationState(this);
        appGameState      = new AppGameState(this);

        appState = appSplashState; 
    }

    public void  setState(AppState newState) {appState = newState;}
    public AppState getState() {return appState;}

    public void start(Stage stage){
        appState.start(stage);
    }

    public AppState getAppSplashState() {
        return appSplashState;
    }

    public void setAppSplashState(AppState splashScreenState) {
        this.appSplashState = splashScreenState;
    }

    public AppState getAppCopyrightState() {
        return appCopyrightState;
    }

    public void setAppCopyrightState(AppState copyrightScreenState) {
        this.appCopyrightState = copyrightScreenState;
    }

    public AppState getAppGameState() {
        return appGameState;
    }

    public void setAppGameState(AppState gameScreenState) {
        this.appGameState = gameScreenState;
    }
}