package com.dafreitag.game.machine;

import com.dafreitag.game.states.GameDefeatState;
import com.dafreitag.game.states.GamePlayState;
import com.dafreitag.game.states.GameVictoryState;
import com.dafreitag.app.machine.GameState;
import javafx.stage.Stage;

public class GameMachine {
    GameState gamePlayState;
    GameState gameVictoryState;
    GameState gameDefeatState;
    GameState gameState;

    public GameMachine () {
        gamePlayState    = new GamePlayState(this);
        gameVictoryState = new GameVictoryState(this);
        gameDefeatState  = new GameDefeatState(this);

        gameState = gamePlayState; 
    }

    public void setState(GameState newState) {gameState = newState;}
    public GameState getState() {return gameState;}

    public void start(Stage stage){
        gameState.start(stage);
    }

    public GameState getGamePlayState() {
        return gamePlayState;
    }

    public void setGamePlayState(GameState gamePlayState) {
        this.gamePlayState = gamePlayState;
    }

    public GameState getGameVictoryState() {
        return gameVictoryState;
    }

    public void setGameVictoryState(GameState gameVictoryState) {
        this.gameVictoryState = gameVictoryState;
    }

    public GameState getGameDefeatState() {
        return gameDefeatState;
    }

    public void setGameDefeatState(GameState gameDefeatState) {
        this.gameVictoryState = gameDefeatState;
    }
}